#!/bin/sh
#Export FBINTF

SVNROOT=svn://olympus/svn/mwa/lazarus-packages

if [ -n "`ps ax|grep libreoffice|grep -v grep`" ]; then
  echo "libreoffice is running. Please terminate all instances of libreoffice before running this script"
  exit 1
fi

if grep 'tba,' changelog >/dev/null; then
  sed -i "0,/([0-9]\+\.[0-9]\+-[0-9]\+).*\$/{s/\(([0-9]\+\.[0-9]\+-[0-9]\+)\).*\$/ \1 `date '+%a, %d %b %Y %H:%M:%S %z'`/}" changelog
fi

VERSION=`grep 'version *([0-9]\+\.[0-9]\+-[0-9]\+)' changelog | head -n 1| sed 's/.*version *(\([0-9]\+\.[0-9]\+-[0-9]\+\)).*/\1/'`
V1=`echo "$VERSION"|sed 's/\([0-9]\+\)\.\([0-9]\+\)-\([0-9]\+\)/\1/'`
V2=`echo "$VERSION"|sed 's/\([0-9]\+\)\.\([0-9]\+\)-\([0-9]\+\)/\2/'`
V3=`echo "$VERSION"|sed 's/\([0-9]\+\)\.\([0-9]\+\)-\([0-9]\+\)/\3/'`
TAG=$V1-$V2-$V3

sed -i "s/FBIntf_Major.*/FBIntf_Major = $V1;/
s/FBIntf_Minor.*/FBIntf_Minor = $V2;/
s/FBIntf_Release.*/FBIntf_Release = $V3;/
s/FBIntf_Version.*/FBIntf_Version = '$V1.$V2.$V3';/" IB.pas
sed -i "/<License/,/<Files/{s/<Version.*\/>/<Version Major=\"$V1\" Minor=\"$V2\" Release = \"$V3\" \/>/}" fbintf.lpk
sed -i "s/<VersionInfo Name=\"MajorVer\">[0-9]\+<\/VersionInfo>/<VersionInfo Name=\"MajorVer\">$V1<\/VersionInfo>/
s/<VersionInfo Name=\"MinorVer\">[0-9]\+<\/VersionInfo>/<VersionInfo Name=\"MinorVer\">$V2<\/VersionInfo>/
s/<VersionInfo Name=\"Release\">[0-9]\+<\/VersionInfo>/<VersionInfo Name=\"Release\">$V3<\/VersionInfo>/
s/<VersionInfoKeys Name=\"FileVersion\">[0-9\.]\+<\/VersionInfoKeys>/<VersionInfoKeys Name=\"FileVersion\">$V1.$V2.$V3.0<\/VersionInfoKeys>/
s/<VersionInfoKeys Name=\"ProductVersion\">[0-9\.]\+<\/VersionInfoKeys>/<VersionInfoKeys Name=\"ProductVersion\">$V1.$V2.$V3.0<\/VersionInfoKeys>/" fbintf.dproj

svn commit -m ""
svn rm $SVNROOT/fbintf/tags/R$TAG -m "" >/dev/null
svn copy $SVNROOT/fbintf/trunk $SVNROOT/fbintf/tags/R$TAG -m "Release $TAG"
cd /tmp
rm -rf fbintf
svn export $SVNROOT/fbintf/tags/R$TAG fbintf
cd fbintf

find . -name '*.orig' -exec rm -f '{}' \;
#Generate Documentation
find . -name '*.odt' -execdir libreoffice --invisible --convert-to pdf '{}' \;
find . -name '*.odt' -exec rm '{}' \;
find . -name '*.lps' -exec rm '{}' \;
rm release.sh
cd ..
tar -zcf fbintf$VERSION.tar.gz fbintf
cd fbintf
#convert to dos format
find . -name '*.bat' -exec todos '{}' \;
find . -name '*.log' -exec todos '{}' \;
find . -name '*.fpc' -exec todos '{}' \;
find . -name '*.txt' -exec todos '{}' \;
find . -name '*.lpk' -exec todos '{}' \;
find . -name '*.pas' -exec todos '{}' \;
find . -name '*.lpm' -exec todos '{}' \;
find . -name '*.inc' -exec todos '{}' \;
find . -name '*.lpr' -exec todos '{}' \;
find . -name '*.lpi' -exec todos '{}' \;
cd ..
echo `pwd`
zip -r fbintf$VERSION.zip fbintf

